﻿Imports System
Imports System.IO
Imports System.Threading
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.Threading.Tasks
Imports System.Collections
Imports System.Text

Public Class Form1
    Delegate Sub WriteButton5TextDelegate(ByVal Value As String)
    Private WriteButton5TextInstance As New WriteButton5TextDelegate(AddressOf WriteButton5Text)
    Delegate Sub WriteDataGridView1Delegate(ByVal i As Int32, ByVal Value As String)
    Private WriteDataGridView1Instance As New WriteDataGridView1Delegate(AddressOf WriteDataGridView1)
    Delegate Sub ForeColorDataGridView1Delegate(ByVal c As Int32, ByVal d As Int32, ByVal Value As System.Drawing.Color)
    Private ForeColorDataGridView1Instance As New ForeColorDataGridView1Delegate(AddressOf ForeColorDataGridView1)

    Delegate Sub WriteListBoxDelegate(ByVal Value As Int32)
    Private WriteListBox1Instance As New WriteListBoxDelegate(AddressOf WriteListBox1)
    Delegate Sub WriteListBoxErrorDelegate(ByVal Value As Int32)
    Private WriteListBox1ErrorInstance As New WriteListBoxErrorDelegate(AddressOf WriteListBox1Error)
    'PTSとPCRの同期 PTSが先にくる PCRはPTSより小さい
    'PTSをAM01:00:00からにPTS=324000000(基本はPCR PTSより遅れてくる、PTSより過去時間)
    'PCR をAM1:00:00からにPCR=324000000L * 300
    Private Const DataGriedViewColum0Width = 350
    Private Const DataGriedViewColum1Width = 110
    Private Const DataGriedViewColum2Width = 150
    Private Const DataGriedViewColum3Width = 82
    Private Const DataGriedViewColum4Width = 82
    Private Const DataGriedViewScrollBWidth = 20

    Private _sorder As Int32 = 0
    Private bIsExecute As Boolean
    'Private nVideo(&H5DFFF) As Byte         ' データ格納用配列188X8192 188X4096=&HBC000 188X2048=5E000

    '-----------------------------------------------------------------------------
    '対象ファイル格納フォルダ選択
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim srcPath2 As String = SelectFolder(Me, srcPath)
        If String.IsNullOrEmpty(srcPath2) Then Exit Sub
        Dim files As String() = System.IO.Directory.GetFiles(srcPath2, "*.ts", System.IO.SearchOption.TopDirectoryOnly)
        'DataGridView1ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Dim fileI As String

        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 40 Then Me.DataGridView1.RowCount = 40

        Me.DataGridView1.ClearSelection()

    End Sub

    'ファイル選択
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim files As String() = SelectFiles(srcPath)
        If files Is Nothing Then Exit Sub
        Dim fileI As String

        'DataGridView1ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 40 Then Me.DataGridView1.RowCount = 40

        Me.DataGridView1.ClearSelection()

    End Sub

    '全クリア
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim rowCount As Int32 = Me.DataGridView1.Rows.Count

        For i As Int32 = 0 To rowCount - 2
            Me.DataGridView1.Rows.RemoveAt(0)
        Next
        Me.DataGridView1.RowCount = 40
        Me.DataGridView1.Columns(0).Width = DataGriedViewColum0Width
        Me.DataGridView1.Columns(1).Width = DataGriedViewColum1Width
        Me.DataGridView1.Columns(2).Width = DataGriedViewColum2Width
        Me.DataGridView1.Columns(3).Width = DataGriedViewColum3Width
        Me.DataGridView1.Columns(4).Width = DataGriedViewColum4Width

        Me.DataGridView1.ClearSelection()
        dgvRowIndex = 0

    End Sub

    '選択クリア
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim dgv1 As DataGridView = Me.DataGridView1
        If dgv1.SelectedRows.Count < 1 Then Exit Sub

        Dim r As DataGridViewRow
        For Each r In dgv1.SelectedRows
            If Not r.IsNewRow Then
                dgv1.Rows.Remove(r)
            End If
        Next r

        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim VItemWidth As Int32
        Dim VItem1Width As Int32 = DataGriedViewColum0Width
        Dim j As Int32 = 0
        For i As Int32 = 0 To dgv1.RowCount - 1
            VItemWidth = CInt(g.MeasureString(dgv1(0, i).Value, dgv1.Font, Integer.MaxValue, sf).Width)
            If VItem1Width < VItemWidth Then VItem1Width = VItemWidth
            If Not String.IsNullOrEmpty(dgv1(0, i).Value) Then j += 1
        Next
        dgv1.RowCount = j + 1
        dgv1.Columns(0).Width = VItem1Width
        _sorder = SortOrder.Ascending
        DataGridView1.Sort(New CustomComparer(_sorder))

        If dgv1.RowCount < 40 Then dgv1.RowCount = 40
        dgv1.ClearSelection()
        dgvRowIndex = 0

    End Sub

    Private dgvRowIndex As Int32 = 0
    Private ItemWidth As Int32

    '結合
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If bIsExecute = True Then Exit Sub
        If String.IsNullOrEmpty(Me.DataGridView1(0, 0).Value) Then
            bIsExecute = False
            Exit Sub
        End If

        Me.ControlBox = False
        bIsExecute = True
        Me.Button1.Enabled = False
        Me.Button2.Enabled = False
        Me.Button3.Enabled = False
        Me.Button4.Enabled = False

        Dim srcFileName As String = ""
        Dim dstFileName As String = Path.GetDirectoryName(Me.DataGridView1(0, 0).Value)
        If Not (dstFileName.Substring(dstFileName.Length - 1, 1) = "\") Then dstFileName += "\"
        dstFileName += (Path.GetFileNameWithoutExtension(Me.DataGridView1(0, 0).Value) + ".000" + Path.GetExtension(Me.DataGridView1(0, 0).Value))

        Me.Button5.Image = My.Resources.ajax_loader_2
        Me.Button5.ForeColor = Color.DarkRed
        Me.ListBox1.Items.Add("")
        ListColor.Add(0)

        Dim psi As New System.Diagnostics.ProcessStartInfo()
        Dim pId As New System.Diagnostics.Process
        psi.FileName = System.Environment.GetEnvironmentVariable("ComSpec") 'ComSpecのパスを取得する
        psi.RedirectStandardInput = False   '標準入力を読取らない
        psi.RedirectStandardOutput = True   '標準出力をリダイレクトする
        psi.RedirectStandardError = True    '標準エラー出力を　　〃
        psi.UseShellExecute = False         'シェルは使えない
        psi.CreateNoWindow = True           'ウィンドウを表示しないようにする

        For i As Int32 = 0 To Me.DataGridView1.RowCount - 1
            If (Not String.IsNullOrEmpty(Me.DataGridView1(0, i).Value)) AndAlso (Not String.IsNullOrEmpty(Path.GetDirectoryName(Me.DataGridView1(0, i).Value))) Then
                If 0 < i Then
                    srcFileName += " "
                End If
                srcFileName += ("""" + Me.DataGridView1(0, i).Value + """")
            End If
        Next
        Me.Button5.ForeColor = Color.DarkRed
        Me.Button5.Image = My.Resources.ajax_loader_2

        Try
            'コマンドラインを指定（"/c"は実行後閉じるために必要）
            Dim AppPath As String = Application.ExecutablePath
            'psi.Arguments = "/c " + AppPath.Substring(0, AppPath.IndexOf("TsConnectorGUI.exe", StringComparison.OrdinalIgnoreCase)) + "TsConnector.exe " + srcFileName + " " + """" + dstFileName + """"
            psi.Arguments = "/c TsConnector.exe " + srcFileName + " " + """" + dstFileName + """"

            '起動
            pId = System.Diagnostics.Process.Start(psi)
            '出力の監視を開始
            Me.Invoke(WriteListBox1Instance, New Object() {&HD})
            Me.Invoke(WriteListBox1Instance, New Object() {&HA})

            Dim stdoutWatcher = New Thread(New ParameterizedThreadStart(AddressOf standardOutputWatcherThread))
            stdoutWatcher.Start(pId.StandardOutput)
            Dim stderrWatcher = New Thread(New ParameterizedThreadStart(AddressOf standardErrorWatcherThread))
            stderrWatcher.Start(pId.StandardError)
            Do While stderrWatcher.IsAlive = True
                System.Threading.Thread.Sleep(1)
                System.Windows.Forms.Application.DoEvents()
            Loop

            System.Threading.Thread.Sleep(20)

        Catch ex As System.Exception
            'ex.MessageにはCrLfが入ってないので足しておく
            WriteListBox1ErrorString(vbCrLf + ex.Message + vbCrLf)

        Finally
            pId.Close()
            pId.Dispose()
            pId = Nothing

        End Try

        Me.Button5.ForeColor = Color.Black
        Me.Button5.Image = Nothing
        Me.Button5.Text = "開始"
        Me.Button1.Enabled = True
        Me.Button2.Enabled = True
        Me.Button3.Enabled = True
        Me.Button4.Enabled = True
        dgvRowIndex = 0
        bIsExecute = False
        Me.ControlBox = True

    End Sub

    '強制終了
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim lngProcessSnapHandle As Long
        Dim udtProcessEntry32 As New PROCESSENTRY32
        Dim strProcessID As String
        Dim strExeFileName As String
        Dim lngWin32apiResultCode As Long
        Dim h32ProcessID As Int32

        ' プロセスのスナップショットを取得
        lngProcessSnapHandle = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
        ' プロセスのスナップショットを取得できない場合は
        If lngProcessSnapHandle = (-1) Then
            ' エラーを表示して終了
            MsgBox("スナップショットの取得は失敗")
            Exit Sub
        End If
        ' プロセスエントリを定義する構造体を初期化
        udtProcessEntry32.dwSize = Marshal.SizeOf(udtProcessEntry32)
        ' 最初のプロセスエントリを取得できたときは
        If Process32First(lngProcessSnapHandle, udtProcessEntry32) <> False Then
            ' 2番目以降のプロセスエントリを取得できる間は
            Do
                ' プロセスIDと実行ファイルのフルパス名を取り出し
                With udtProcessEntry32
                    strProcessID = Hex(.th32ProcessID)
                    strExeFileName = .szExeFile.ToString
                    ' プロセスIDと実行ファイルのフルパス名を追加
                    If -1 < strExeFileName.IndexOf("TsConnector.exe", StringComparison.OrdinalIgnoreCase) Then
                        h32ProcessID = .th32ProcessID
                    End If
                End With
                'i = i + 1
                ' 次のプロセスエントリを取得
            Loop While Process32Next(lngProcessSnapHandle, udtProcessEntry32) <> False
        Else        ' エラーを表示して終了
            MsgBox("プロセスエントリの取得は失敗")
            Exit Sub
        End If
        ' プロセスのスナップショットを開放
        lngWin32apiResultCode = CloseHandle(lngProcessSnapHandle)

        ProcessTerminate(h32ProcessID)

        System.Threading.Thread.Sleep(1000)

        ForeColorDataGridView1(4, dgvRowIndex, System.Drawing.Color.Red)
        Me.DataGridView1(4, dgvRowIndex).Value = "強制終了"

        Me.ControlBox = True

    End Sub

    'DataGridViewのプロパティAllowDropをTrueに
    Private dragBoxFromMouseDown As Rectangle
    Private rowIndexFromMouseDown As Integer
    Private rowIndexOfItemUnderMouseToDrop As Integer
    Dim listRowIndexSelect As List(Of Integer) = New List(Of Integer)

    Private Sub DataGridView1_CellMouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.CellMouseMove
        If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
            ' If the mouse moves outside the rectangle, start the drag.
            If dragBoxFromMouseDown <> Rectangle.Empty And Not dragBoxFromMouseDown.Contains(e.X, e.Y) Then
                ' Proceed with the drag and drop, passing in the list item.
                Dim dropEffect As DragDropEffects = Me.DataGridView1.DoDragDrop(Me.DataGridView1.Rows(rowIndexFromMouseDown), DragDropEffects.Move)
            End If
        End If

    End Sub

    Private Sub DataGridView1_ColumnHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.ColumnHeaderMouseClick
        If bIsExecute Then Exit Sub
        Dim j As Int32 = 0
        Dim dgvRowCount As Int32 = Me.DataGridView1.RowCount
        For i As Int32 = 0 To dgvRowCount - 1
            If Me.DataGridView1.NewRowIndex = i Then Exit For
            If String.IsNullOrEmpty(Me.DataGridView1(0, i).Value) Then
                Me.DataGridView1.Rows.RemoveAt(j)
                dgvRowCount -= 1
                i -= 1
            Else
                j += 1
            End If
        Next
        'Me.DataGridView1.RowCount = i + 1
        Me.DataGridView1.RowCount = dgvRowCount

        If _sorder = SortOrder.Ascending Then
            _sorder = SortOrder.Descending
        Else
            _sorder = SortOrder.Ascending
        End If
        DataGridView1.Sort(New CustomComparer(_sorder))

        If Me.DataGridView1.RowCount < 40 Then DataGridView1.RowCount = 40

        Me.DataGridView1.ClearSelection()

    End Sub

    Private Sub DataGridView1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragDrop
        If e.Data.GetDataPresent(GetType(DataGridViewRow)) Then
            listRowIndexSelect.Clear()
            Dim dgvr As DataGridViewRow
            For Each dgvr In Me.DataGridView1.Rows
                If dgvr.Selected Then
                    listRowIndexSelect.Add(dgvr.Index)
                End If
            Next dgvr

            Dim clientPoint As Point = Me.DataGridView1.PointToClient(New Point(e.X, e.Y))
            rowIndexOfItemUnderMouseToDrop = Me.DataGridView1.HitTest(clientPoint.X, clientPoint.Y).RowIndex

            If e.Effect = DragDropEffects.Move Then
                'データセットにバインドしていない場合
                Dim rowToMove As DataGridViewRow = e.Data.GetData(GetType(DataGridViewRow))
                DataGridView1.Rows.RemoveAt(rowIndexFromMouseDown)
                DataGridView1.Rows.Insert(rowIndexOfItemUnderMouseToDrop, rowToMove)

            End If

        Else
            'ドロップされたすべてのファイル名を取得する
            Dim files As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())
            If Not files Is Nothing Then
                'DataGridView1ファイル名追加
                'Ver 2.0.2.6--------------------------------------------------------------------------
                'Me.DataGridView1.Rows.Clear()
                Dim i As Int32
                For i = 0 To Me.DataGridView1.RowCount - 1
                    If String.IsNullOrEmpty(Me.DataGridView1(0, i).Value) Then Exit For
                Next
                'Dim i As Int32 = 0
                '-------------------------------------------------------------------------------------
                Dim fileI As String
                For Each fileI In files
                    If Path.GetExtension(fileI).ToLower = ".ts" Then
                        setFilesToDataGridView(i, fileI)
                        i += 1
                    End If
                Next
                If Me.DataGridView1.RowCount < 40 Then Me.DataGridView1.RowCount = 40
                Me.DataGridView1.ClearSelection()
            End If

        End If

    End Sub

    Private Sub DataGridView1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            'ドラッグされたデータ形式を調べ、ファイルのときはコピーとする
            e.Effect = DragDropEffects.Copy
        Else
            'ファイル以外は受け付けない
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub DataGridView1_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragOver
        e.Effect = DragDropEffects.Move

    End Sub

    Private Sub DataGridView1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridView1.MouseDown
        ' Get the index of the item the mouse is below.
        rowIndexFromMouseDown = Me.DataGridView1.HitTest(e.X, e.Y).RowIndex

        If rowIndexFromMouseDown <> -1 Then
            Dim dragSize As Size = SystemInformation.DragSize
            dragBoxFromMouseDown = New Rectangle(New Point(e.X - dragSize.Width / 2, e.Y - dragSize.Height / 2), dragSize)
        Else
            dragBoxFromMouseDown = Rectangle.Empty
        End If

    End Sub

    Private Sub DataGridView1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridView1.MouseMove
        If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
            If dragBoxFromMouseDown <> Rectangle.Empty And Not dragBoxFromMouseDown.Contains(e.X, e.Y) Then
                Dim dropEffect As DragDropEffects = Me.DataGridView1.DoDragDrop(Me.DataGridView1.Rows(rowIndexFromMouseDown), DragDropEffects.Move)
            End If
        End If

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim fileName As String = Application.StartupPath + "\settings.config"
        Dim appSettings As New Settings
        Dim bf1 As New BinaryFormatter

        Dim fs1 As New System.IO.FileStream(fileName, System.IO.FileMode.Create)
        '変数に設定
        With appSettings
            .srcPath = srcPath
            .dstPath = dstPath
        End With
        'シリアル化し、バイナリファイルに保存する
        bf1.Serialize(fs1, appSettings)

        fs1.Close()

    End Sub

    Private Sub Form1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop
        'ドロップされたすべてのファイル名を取得する
        Dim files As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())
        Me.DataGridView1.Rows.Clear()

        'ドロップされたファイルのパスをすべて表示
        Dim fileI As String
        Dim i As Int32 = 0
        If 0 < files.Length Then
            For Each fileI In files
                If Path.GetExtension(fileI).ToLower = ".ts" Then
                    setFilesToDataGridView(i, fileI)
                    i += 1
                End If
            Next
        End If
        If DataGridView1.RowCount < 40 Then Me.DataGridView1.RowCount = 40
        Me.DataGridView1.ClearSelection()

    End Sub

    Private Sub Form1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim fileName As String = Application.StartupPath + "\settings.config"
        If System.IO.File.Exists(fileName) Then
            Dim appSettings As New Settings
            Dim bf2 As New BinaryFormatter
            Dim fs2 As New System.IO.FileStream(fileName, System.IO.FileMode.Open)
            appSettings = CType(bf2.Deserialize(fs2), Settings)
            fs2.Close()
            '変数に設定
            With appSettings
                srcPath = .srcPath
                dstPath = .dstPath
            End With
            appSettings = Nothing
            If Not System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(srcPath)) Then srcPath = ""
            If Not System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(dstPath)) Then dstPath = ""
        Else
            srcPath = ""
            dstPath = ""
        End If

        Me.DataGridView1.DefaultCellStyle.SelectionBackColor = SystemColors.InactiveCaption
        Me.DataGridView1.DefaultCellStyle.SelectionForeColor = Color.Black
        Me.DataGridView1.Rows.Clear()

        'ドロップされたファイルのパスをすべて表示
        Dim cmds As String() = System.Environment.GetCommandLineArgs()
        Dim fileI As String
        Dim i As Int32 = 0
        Dim j As Int32 = 0
        If 1 < cmds.Length Then
            For Each fileI In cmds
                If 0 < i Then
                    If Path.GetExtension(fileI).ToLower = ".ts" Then
                        setFilesToDataGridView(j, fileI)
                        j += 1
                    End If
                End If
                i += 1
            Next
        End If
        If DataGridView1.RowCount < 40 Then Me.DataGridView1.RowCount = 40
        Me.DataGridView1.ClearSelection()

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If 762 < Me.Width Then
            Dim xx As Int32 = Me.Width - Me.DataGridView1.Width - (762 - 663)
            'DataGridView
            Me.DataGridView1.Width += xx
            If DataGriedViewColum0Width < Me.DataGridView1.Width - (DataGriedViewColum1Width + DataGriedViewColum2Width + DataGriedViewColum3Width + DataGriedViewColum4Width + DataGriedViewScrollBWidth) Then
                Me.DataGridView1.Columns(0).Width = Me.DataGridView1.Width - DataGriedViewColum1Width - DataGriedViewColum2Width - DataGriedViewColum3Width - DataGriedViewColum4Width - DataGriedViewScrollBWidth
            End If
            'Button
            Me.Button1.Left += xx
            Me.Button2.Left += xx
            Me.Button3.Left += xx
            Me.Button4.Left += xx
            Me.Button5.Left += xx
            Me.Button6.Left += xx
        End If
        If 474 < Me.Height Then
            Dim yy As Int32 = Me.Height - Me.DataGridView1.Height - (474 - 395)
            'DataGridView
            Me.DataGridView1.Height += yy
            'Button
            Me.Button3.Top += yy
            Me.Button4.Top += yy
            Me.Button5.Top += yy
            Me.Button6.Top += yy
        End If

    End Sub

    Private Sub 入出力設定ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 入出力設定ToolStripMenuItem.Click
        If bIsExecute Then Exit Sub

        Dim fm As New Form2
        Dim prevsrcPath As String = srcPath

        fm.ShowDialog(Me)
        fm.Dispose()

        If Not prevsrcPath = srcPath Then
            'クリア
            Button3_Click(sender, e)
        End If

    End Sub

    Private Sub バージョン情報ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles バージョン情報ToolStripMenuItem.Click
        MsgBox("    TsConnector" + vbCrLf + _
               "      Ver 2.1.3.0")

    End Sub

    Private Sub setFilesToDataGridView(ByVal i As Int32, ByVal fileI As String)
        Dim fileO As String
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim ItemWidth As Int32

        If Path.GetExtension(fileI).ToLower = ".ts" Then
            Me.DataGridView1.RowCount += 1
            Me.DataGridView1(0, i).Value = fileI
            ItemWidth = CInt(g.MeasureString(fileI, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
            If Me.DataGridView1.Columns(0).Width < ItemWidth Then Me.DataGridView1.Columns(0).Width = ItemWidth
            Me.DataGridView1(1, i).Value = System.IO.File.GetLastWriteTime(fileI)

            fileO = dstPath
            If String.IsNullOrEmpty(dstPath) Then
                fileO = Path.GetDirectoryName(fileI)
            End If
            If Not (fileO.Substring(fileO.Length - 1, 1) = "\") Then fileO += "\"
            fileO += (Path.GetFileNameWithoutExtension(fileI) + ".000" + Path.GetExtension(fileI))

        End If

    End Sub

    Private Sub WriteButton5Text(ByVal Value As String)
        Button5.Text = Value

    End Sub

    Private Sub WriteDataGridView1(ByVal i As Int32, ByVal Value As String)
        DataGridView1(2, i).Value = Value

    End Sub

    Private Sub ForeColorDataGridView1(ByVal nCol As Int32, ByVal nRow As Int32, ByVal Value As System.Drawing.Color)
        DataGridView1(nCol, nRow).Style.ForeColor = Value

    End Sub

    Private List1Index As Int32 = 0
    Private Push As Byte
    Private sTmp As New System.Text.StringBuilder()
    Private sTmpS As New System.Text.StringBuilder()
    Private sTmpE As New System.Text.StringBuilder()
    Private sTmpES As New System.Text.StringBuilder()
    Private ListColor As New List(Of Int32)
    Private stdIn As Int32 = 0
    Private strDGV As String = ""
    Private strDGVSV As String = ""

    '標準出力監視スレッド
    Private Sub standardOutputWatcherThread(ByVal parameter As Object)
        Dim reader As System.IO.StreamReader = parameter
        stdIn = 1
        Do
            Me.Invoke(WriteListBox1Instance, New Object() {reader.Read()})
        Loop Until reader.EndOfStream
        reader.Close()
        stdIn = 0

    End Sub

    '標準エラー出力監視スレッド
    Private Sub standardErrorWatcherThread(ByVal parameter As Object)
        Dim reader As System.IO.StreamReader = parameter
        Do
            System.Threading.Thread.Sleep(10)
        Loop Until stdIn = 0
        Do
            Me.Invoke(WriteListBox1ErrorInstance, New Object() {reader.Read()})
        Loop Until reader.EndOfStream
        reader.Close()

    End Sub

    Private Sub WriteListBox1(ByVal Value As Int32)
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()

        Select Case Value
            Case 0
            Case &HD
                Push = &HD
            Case &HA
                If Push = &HD Then
                    If sTmp.Length < ListBox1.Items(List1Index).Length Then
                        sTmp.Append(ListBox1.Items(List1Index).ToString.Substring(sTmp.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmp.ToString
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    Push = 0
                    List1Index += 1
                    If -1 < sTmp.ToString.IndexOf("開始時刻") Then
                        Me.DataGridView1(3, dgvRowIndex).Value = sTmp.ToString.Substring(5).Trim
                    ElseIf -1 < sTmp.ToString.IndexOf("終了時刻") Then
                        Me.DataGridView1(4, dgvRowIndex).Value = sTmp.ToString.Substring(5).Trim
                    ElseIf -1 < sTmp.ToString.IndexOf("処理開始") Then
                        dgvRowIndex = CInt(sTmp.ToString.Substring(5).Trim) - 1
                    ElseIf -1 < sTmp.ToString.IndexOf("接続完了") Then
                        strDGV = "PCR,PTS,DTS 接続完了 100%"
                    End If
                    If Not strDGV.Equals(strDGVSV) Then
                        Me.DataGridView1(2, dgvRowIndex).Value = strDGV
                        ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                        If Me.DataGridView1.Columns(2).Width < ItemWidth Then Me.DataGridView1.Columns(2).Width = ItemWidth
                        strDGVSV = strDGV
                    End If

                    sTmp.Remove(0, sTmp.Length)

                Else
                    sTmp.Append(ChrW(Value))
                End If

            Case Else
                If Push = &HD Then
                    If sTmp.Length < ListBox1.Items(List1Index).Length Then
                        sTmp.Append(ListBox1.Items(List1Index).ToString.Substring(sTmp.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmp.ToString
                    If -1 < sTmp.ToString.IndexOf("検索中") Then
                        Me.Button5.Text = sTmp.ToString.Substring(20).Trim
                        strDGV = "PAT,PMT,GOP,PCR 検索中"
                    ElseIf -1 < sTmp.ToString.IndexOf("接続中") Then
                        Me.Button5.Text = sTmp.ToString.Substring(16).Trim
                        strDGV = "PCR,PTS,DTS 接続中"
                    End If
                    If Not strDGV.Equals(strDGVSV) Then
                        Me.DataGridView1(2, dgvRowIndex).Value = strDGV
                        ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                        If Me.DataGridView1.Columns(2).Width < ItemWidth Then Me.DataGridView1.Columns(2).Width = ItemWidth
                        strDGVSV = strDGV
                    End If

                    sTmp.Remove(0, sTmp.Length)
                    Push = 0
                End If
                sTmp.Append(ChrW(Value))
        End Select

    End Sub

    Private Sub WriteListBox1String(ByVal Value As String)
        sTmpS.Append(Value)
        Select Case AscW(sTmpS(sTmpS.Length - 1))
            Case &HA
                If AscW(sTmpS(sTmpS.Length - 2)) = &HD Then
                    sTmpS.Remove(sTmpS.Length - 2, 2)
                    If sTmpS.Length < ListBox1.Items(List1Index).Length Then
                        sTmpS.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpS.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpS.ToString
                    ListColor.Item(List1Index) = 1
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    List1Index += 1
                    sTmpS.Remove(0, sTmpS.Length)
                End If

            Case &HD
                sTmpS.Remove(sTmpS.Length - 1, 1)
                If sTmpS.Length < ListBox1.Items(List1Index).Length Then
                    sTmpS.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpS.Length))
                End If
                ListBox1.Items(List1Index) = sTmpS.ToString
                ListColor.Item(List1Index) = 1
                sTmpS.Remove(0, sTmpS.Length)

        End Select

    End Sub

    Private Sub WriteListBox1Error(ByVal Value As Int32)
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()

        Select Case Value
            Case 0
            Case &HD
                Push = &HD
            Case &HA
                If Push = &HD Then
                    If sTmpE.Length < ListBox1.Items(List1Index).Length Then
                        sTmpE.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpE.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpE.ToString
                    ListColor.Item(List1Index) = 1
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    Push = 0
                    List1Index += 1

                    ForeColorDataGridView1(2, dgvRowIndex, System.Drawing.Color.Red)
                    Me.DataGridView1(2, dgvRowIndex).Value = sTmpE.ToString
                    ItemWidth = CInt(g.MeasureString(sTmpE.ToString, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView1.Columns(2).Width < ItemWidth Then Me.DataGridView1.Columns(2).Width = ItemWidth

                    sTmpE.Remove(0, sTmpE.Length)
                Else
                    sTmpE.Append(ChrW(Value))
                End If

            Case Else
                If Push = &HD Then
                    If sTmpE.Length < ListBox1.Items(List1Index).Length Then
                        sTmpE.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpE.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpE.ToString
                    ListColor.Item(List1Index) = 1

                    ForeColorDataGridView1(2, dgvRowIndex, System.Drawing.Color.Red)
                    Me.DataGridView1(2, dgvRowIndex).Value = sTmpE.ToString
                    ItemWidth = CInt(g.MeasureString(sTmpE.ToString, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView1.Columns(2).Width < ItemWidth Then Me.DataGridView1.Columns(2).Width = ItemWidth

                    sTmpE.Remove(0, sTmpE.Length)
                    Push = 0
                End If
                sTmpE.Append(ChrW(Value))

        End Select

    End Sub

    Private Sub WriteListBox1ErrorString(ByVal Value As String)
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()

        sTmpES.Append(Value)
        Select Case AscW(sTmpES(sTmpES.Length - 1))
            Case &HA
                If AscW(sTmpES(sTmpES.Length - 2)) = &HD Then
                    sTmpES.Remove(sTmpES.Length - 2, 2)
                    If sTmpES.Length < ListBox1.Items(List1Index).Length Then
                        sTmpES.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpES.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpES.ToString
                    ListColor.Item(List1Index) = 1
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    List1Index += 1
                    ForeColorDataGridView1(2, dgvRowIndex, System.Drawing.Color.Red)
                    Me.DataGridView1(2, dgvRowIndex).Value = sTmpES.ToString
                    ItemWidth = CInt(g.MeasureString(sTmpES.ToString, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView1.Columns(2).Width < ItemWidth Then Me.DataGridView1.Columns(2).Width = ItemWidth

                    sTmpES.Remove(0, sTmpES.Length)

                End If

            Case &HD
                sTmpES.Remove(sTmpES.Length - 1, 1)
                If sTmpES.Length < ListBox1.Items(List1Index).Length Then
                    sTmpES.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpES.Length))
                End If
                ListBox1.Items(List1Index) = sTmpES.ToString
                ListColor.Item(List1Index) = 1
                ForeColorDataGridView1(2, dgvRowIndex, System.Drawing.Color.Red)
                Me.DataGridView1(2, dgvRowIndex).Value = sTmpES.ToString
                ItemWidth = CInt(g.MeasureString(sTmpES.ToString, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                If Me.DataGridView1.Columns(2).Width < ItemWidth Then Me.DataGridView1.Columns(2).Width = ItemWidth

                sTmpES.Remove(0, sTmpES.Length)

        End Select

    End Sub

End Class

'IComparerインターフェイスを実装した、並び替える方法を定義したクラス
Public Class CustomComparer
    Implements IComparer
    Private sOrder As Integer
    Private comparer As Comparer

    Public Sub New(ByVal order As SortOrder)
        Me.sOrder = IIf(order = SortOrder.Descending, -1, 1)
        Me.comparer = New Comparer(System.Globalization.CultureInfo.CurrentCulture)

    End Sub

    '並び替え方を定義する
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        Dim result As Integer = 0

        Dim rowx As DataGridViewRow = CType(x, DataGridViewRow)
        Dim rowy As DataGridViewRow = CType(y, DataGridViewRow)
        'Ver 2.0.2.6---------------------------------------------------------------------------
        Dim strX As New StringBuilder
        Dim strY As New StringBuilder
        Dim intX As Int32 = 0
        '----------------------------------------------------------------------------------------

        'はじめの列のセルの値を比較し、同じならば次の列を比較する
        For i As Integer = 0 To rowx.Cells.Count - 1
            'Ver 2.0.2.6------------------------------------------------------------------------
            For j As Int32 = 0 To rowx.Cells(i).Value.ToString.Length - 1
                If Not IsNumeric(rowx.Cells(i).Value.ToString.Substring(j, 1)) Then
                    If intX <> 0 Then
                        strX.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                        intX = 0
                    End If
                    strX.Append(rowx.Cells(i).Value.ToString.Substring(j, 1))
                Else
                    intX = intX * 10 + CInt(rowx.Cells(i).Value.ToString.Substring(j, 1))
                End If
            Next
            If intX <> 0 Then
                strX.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                intX = 0
            End If

            For j As Int32 = 0 To rowy.Cells(i).Value.ToString.Length - 1
                If Not IsNumeric(rowy.Cells(i).Value.ToString.Substring(j, 1)) Then
                    If intX <> 0 Then
                        strY.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                        intX = 0
                    End If
                    strY.Append(rowy.Cells(i).Value.ToString.Substring(j, 1))
                Else
                    intX = intX * 10 + CInt(rowy.Cells(i).Value.ToString.Substring(j, 1))
                End If
            Next
            If intX <> 0 Then
                strY.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                intX = 0
            End If
            '----------------------------------------------------------------------------------
            result = Me.comparer.Compare(rowx.Cells(i).Value, rowy.Cells(i).Value)
            If result <> 0 Then
                Exit For
            End If
            'Ver 2.0.2.6---------------------------------------------------------------------
            strX.Remove(0, strX.Length)
            strY.Remove(0, strY.Length)
            '---------------------------------------------------------------------------------
        Next i

        '結果を返す
        Return result * Me.sOrder

    End Function

End Class

<Serializable()> _
Public Class Settings
    Public srcPath As String
    Public dstPath As String
End Class
